*     Program: TUFR4.PRG
*    Software: The Ultimate FoxPro Reference
*    Customer: Hentzenwerke
*      Author: Whil Hentzen
*      Notice: Copyright (c) 1992-93 Hentzenwerke
*            : All Rights Reserved
*            :
*     Contact: Hentzenwerke
*            : PO Box 17343
*            : Milwaukee WI 53217-0343
*            : Voice: 414.332.9876
*            : Fax: 414.963.4999
*            : CompuServe: 70651,2270
*            :
* Description: Interface for access to the TUFR databases
*      Update: 4.0
*       Notes: 
*            :
*      Syntax: (Interactive) do tufr4
*            :
*        Pass: nothing
*            :

if set("talk") = "ON"
 set talk off
 m.cTalkStat = "ON"
else
 m.cTalkStat = "OFF"
endi

m.gcOldHelp = set("help",1)

stor .T. to m.lPickRG
stor .F. to m.lPickBi, m.lPickDE
stor .F. to m.lOnlyNewEntries
stor "" to m.cCrit1, m.cCrit2, m.cCrit3, m.cCrit4, m.cCrit5, m.cCrit6

m.nPURGChoice = 1
m.nPUBiChoice = 1
m.nPUDEChoice = 1
show gets enab
show get m.nPUBiChoice disa
show get m.nPUDEChoice disa

decl aBiItems[12]
aBiItems[1] = "All"
aBiItems[2] = "Byte"
aBiItems[3] = "Cobb FoxPro Journal"
aBiItems[4] = "Data Based Advisor"
aBiItems[5] = "DBMS"
aBiItems[6] = "FoxMasters"
aBiItems[7] = "FoxPro Advisor"
aBiItems[8] = "FoxTalk"
aBiItems[9] = "German FoxPro User Group"
aBiItems[10]= "PC Magazine"
aBiItems[11]= "Pinter FoxPro Letter"
aBiItems[12]= "Other"
decl aDEItems[1]
aDEItems[1] = "All"
decl aRGItems[13]
aRGItems[1] = "All"
aRGItems[2] = "Books"
aRGItems[3] = "Courseware"
aRGItems[4] = "Custom Software Developer"
aRGItems[5] = "Developer Tools/Utilities"
aRGItems[6] = "End User Tools"
aRGItems[7] = "Events"
aRGItems[8] = "Miscellaneous Resources"
aRGItems[9] = "Periodicals (Mags/NL)"
aRGItems[10] = "Trainers"
aRGItems[11] = "User Groups/Organizations"
aRGItems[12] = "Vertical Market Applications"
aRGItems[13] = "Videos"

do TUFR4.SPR

if m.cTalkStat = "ON"
	set talk on
endi

rele m.cTalkStat, m.lPickRG, m.lPickBi, m.lPickDE, m.lOnlyNewEntries, ;
 m.cCrit1, m.cCrit2, m.cCrit3, m.cCrit4, m.cCrit5, m.cCrit6, ;
 m.nPURGChoice, m.nPUBiChoice, m.nPUDEChoice, ;
 aRGItems, aBiItems, aDEItems

retu

************************************************************
func fnSearch
wait wind nowa "Searching"
if m.lPickRG
	do case
	case nPURGChoice = 1
		stor "'a' $ cCategory" to cm0
	case nPURGChoice = 2
		stor "'b' $ cCategory" to cm0
	case nPURGChoice = 3
		stor "'c' $ cCategory" to cm0
	case nPURGChoice = 4
		stor "'d' $ cCategory" to cm0
	case nPURGChoice = 5
		stor "'u' $ cCategory" to cm0
	case nPURGChoice = 6
		stor "'e' $ cCategory" to cm0
	case nPURGChoice = 7
		stor "'n' $ cCategory" to cm0
	case nPURGChoice = 8
		stor "'m' $ cCategory" to cm0
	case nPURGChoice = 9
		stor "'p' $ cCategory" to cm0
	case nPURGChoice = 10
		stor "'t' $ cCategory" to cm0
	case nPURGChoice = 11
		stor "'o' $ cCategory" to cm0
	case nPURGChoice = 12
		stor "'v' $ cCategory" to cm0
	case nPURGChoice = 13
		stor "'i' $ cCategory" to cm0
	endc
	set help to tufr_rg
endi
if m.lPickBi
	do case
	case nPUBiChoice = 1
		stor "'all'  $ cCategory" to cm0
	case nPUBiChoice = 2
		stor "'byte' $ cCategory" to cm0
	case nPUBiChoice = 3
		stor "'cob' $ cCategory" to cm0
	case nPUBiChoice = 4
		stor "'dba'  $ cCategory" to cm0
	case nPUBiChoice = 5
		stor "'dbms' $ cCategory" to cm0
	case nPUBiChoice = 6
		stor "'fm'   $ cCategory" to cm0
	case nPUBiChoice = 7
		stor "'fpa'  $ cCategory" to cm0
	case nPUBiChoice = 8
		stor "'ft'   $ cCategory" to cm0
	case nPUBiChoice = 9
		stor "'dfp'  $ cCategory" to cm0
	case nPUBiChoice = 10
		stor "'pcm'  $ cCategory" to cm0
	case nPUBiChoice = 11
		stor "'pfl'  $ cCategory" to cm0
	case nPUBiChoice = 12
		stor "'oth'  $ cCategory" to cm0
	endc
	set help to tufr_bi	
endi
if m.lPickDE
	if allt(aDEItems[nPUDEChoice]) = "All"
		stor ".T." to cm0
	else
		stor "ctitle = allt(aDEItems[nPUDEChoice])" to cm0
	endi
	set help to tufr_de
endi

stor ".T." to cd1
if lOnlyNewEntries
  stor cd1 + " and dLastMod >= {12/31/93}" to cd1
endi

stor ".T." to cm1
stor ".T." to cm2
stor ".T." to cm3
stor ".F." to cm4
stor ".F." to cm5
stor ".F." to cm6

if ! empt(uppe(allt(cCrit1)))
stor "uppe(allt(cCrit1)) $ uppe(mdescr)" to cm1
stor ".T." to cm2
stor ".T." to cm3
endi
if ! empt(uppe(allt(cCrit2)))
stor "uppe(allt(cCrit2)) $ uppe(mdescr)" to cm2
stor ".T." to cm3
endi
if ! empt(uppe(allt(cCrit3)))
stor "uppe(allt(cCrit3)) $ uppe(mdescr)" to cm3
endi
if ! empt(uppe(allt(cCrit4)))
stor "uppe(allt(cCrit4)) $ uppe(mdescr)" to cm4
stor ".T." to cm5
stor ".T." to cm6
endi
if ! empt(uppe(allt(cCrit5)))
stor "uppe(allt(cCrit5)) $ uppe(mdescr)" to cm5
stor ".T." to cm6
endi
if ! empt(uppe(allt(cCrit6)))
stor "uppe(allt(cCrit6)) $ uppe(mdescr)" to cm6
endi

set helpfil to &cm0 and &cd1 and ;
  (  ;
    (&cm1 and &cm2 and &cm3) ;
      or ;
    (&cm4 and &cm5 and &cm6) ;
  )

help

if ! empt(m.gcOldHelp)
 set help to &gcOldHelp
endi

retu .T.

************************************************************
func fnHelp
set help to TUFRHELP
help
if ! empt(m.gcOldHelp)
 set help to &gcOldHelp
endi
retu .T.

************************************************************
func fnPage
wait wind nowa "Paging"
if lPickRG
	do case
	case nPURGChoice = 1
		stor "'a' $ cCategory" to cm0
	case nPURGChoice = 2
		stor "'b' $ cCategory" to cm0
	case nPURGChoice = 3
		stor "'c' $ cCategory" to cm0
	case nPURGChoice = 4
		stor "'d' $ cCategory" to cm0
	case nPURGChoice = 5
		stor "'u' $ cCategory" to cm0
	case nPURGChoice = 6
		stor "'e' $ cCategory" to cm0
	case nPURGChoice = 7
		stor "'n' $ cCategory" to cm0
	case nPURGChoice = 8
		stor "'m' $ cCategory" to cm0
	case nPURGChoice = 9
		stor "'p' $ cCategory" to cm0
	case nPURGChoice = 10
		stor "'t' $ cCategory" to cm0
	case nPURGChoice = 11
		stor "'o' $ cCategory" to cm0
	case nPURGChoice = 12
		stor "'v' $ cCategory" to cm0
	case nPURGChoice = 13
		stor "'i' $ cCategory" to cm0
	endc
endi
if lPickBi
	do case
	case nPUBiChoice = 1
		stor "'all'  $ cCategory" to cm0
	case nPUBiChoice = 2
		stor "'byte' $ cCategory" to cm0
	case nPUBiChoice = 3
		stor "'cob' $ cCategory" to cm0
	case nPUBiChoice = 4
		stor "'dba'  $ cCategory" to cm0
	case nPUBiChoice = 5
		stor "'dbms' $ cCategory" to cm0
	case nPUBiChoice = 6
		stor "'fm'   $ cCategory" to cm0
	case nPUBiChoice = 7
		stor "'fpa'  $ cCategory" to cm0
	case nPUBiChoice = 8
		stor "'ft'   $ cCategory" to cm0
	case nPUBiChoice = 9
		stor "'dfp'  $ cCategory" to cm0
	case nPUBiChoice = 10
		stor "'pcm'  $ cCategory" to cm0
	case nPUBiChoice = 11
		stor "'pfl'  $ cCategory" to cm0
	case nPUBiChoice = 12
		stor "'oth'  $ cCategory" to cm0
	endc
endi
if lPickDE
	if allt(aDEItems[nPUDEChoice]) = "All"
		stor ".T." to cm0
	else
		stor "ctitle = allt(aDEItems[nPUDEChoice])" to cm0
	endi
endi

stor ".T." to cd1
if lOnlyNewEntries
  stor cd1 + " and dLastMod >= {12/31/93}" to cd1
endi

stor ".T." to cm1
stor ".T." to cm2
stor ".T." to cm3
stor ".F." to cm4
stor ".F." to cm5
stor ".F." to cm6

if ! empt(uppe(allt(cCrit1)))
stor "uppe(allt(cCrit1)) $ uppe(mdescr)" to cm1
stor ".T." to cm2
stor ".T." to cm3
endi
if ! empt(uppe(allt(cCrit2)))
stor "uppe(allt(cCrit2)) $ uppe(mdescr)" to cm2
stor ".T." to cm3
endi
if ! empt(uppe(allt(cCrit3)))
stor "uppe(allt(cCrit3)) $ uppe(mdescr)" to cm3
endi
if ! empt(uppe(allt(cCrit4)))
stor "uppe(allt(cCrit4)) $ uppe(mdescr)" to cm4
stor ".T." to cm5
stor ".T." to cm6
endi
if ! empt(uppe(allt(cCrit5)))
stor "uppe(allt(cCrit5)) $ uppe(mdescr)" to cm5
stor ".T." to cm6
endi
if ! empt(uppe(allt(cCrit6)))
stor "uppe(allt(cCrit6)) $ uppe(mdescr)" to cm6
endi

sele 0
if lPickRG
	use tufr_rg
endi
if lPickBi
	use tufr_bi	
endi
if lPickDE
	use tufr_de
endi

coun for &cm0 and &cd1 and ;
  (  ;
    (&cm1 and &cm2 and &cm3) ;
      or ;
    (&cm4 and &cm5 and &cm6) ;
  ) to nNumRec

=rand(-1)
stor int((nNumRec-1+1)*rand()) to nRecNo
go top
skip nRecNo 
stor cTitle to m.cTitle
use

if lPickRG
	set help to tufr_rg
endi
if lPickBi
	set help to tufr_bi	
endi
if lPickDE
	set help to tufr_de
endi

set helpfilt to &cm0 and &cd1 and ;
  (  ;
    (&cm1 and &cm2 and &cm3) ;
      or ;
    (&cm4 and &cm5 and &cm6) ;
  )

set topic to cTitle
help
set topic to
if ! empt(m.gcOldHelp)
 set help to &gcOldHelp
endi
retu .T.


************************************************************
func fnPrint
wait wind nowa "Searching"
if lPickRG
	do case
	case nPURGChoice = 1
		stor "'a' $ cCategory" to cm0
	case nPURGChoice = 2
		stor "'b' $ cCategory" to cm0
	case nPURGChoice = 3
		stor "'c' $ cCategory" to cm0
	case nPURGChoice = 4
		stor "'d' $ cCategory" to cm0
	case nPURGChoice = 5
		stor "'u' $ cCategory" to cm0
	case nPURGChoice = 6
		stor "'e' $ cCategory" to cm0
	case nPURGChoice = 7
		stor "'n' $ cCategory" to cm0
	case nPURGChoice = 8
		stor "'m' $ cCategory" to cm0
	case nPURGChoice = 9
		stor "'p' $ cCategory" to cm0
	case nPURGChoice = 10
		stor "'t' $ cCategory" to cm0
	case nPURGChoice = 11
		stor "'o' $ cCategory" to cm0
	case nPURGChoice = 12
		stor "'v' $ cCategory" to cm0
	case nPURGChoice = 13
		stor "'i' $ cCategory" to cm0
	endc
endi
if lPickBi
	do case
	case nPUBiChoice = 1
		stor "'all'  $ cCategory" to cm0
	case nPUBiChoice = 2
		stor "'byte' $ cCategory" to cm0
	case nPUBiChoice = 3
		stor "'cob' $ cCategory" to cm0
	case nPUBiChoice = 4
		stor "'dba'  $ cCategory" to cm0
	case nPUBiChoice = 5
		stor "'dbms' $ cCategory" to cm0
	case nPUBiChoice = 6
		stor "'fm'   $ cCategory" to cm0
	case nPUBiChoice = 7
		stor "'fpa'  $ cCategory" to cm0
	case nPUBiChoice = 8
		stor "'ft'   $ cCategory" to cm0
	case nPUBiChoice = 9
		stor "'dfp'  $ cCategory" to cm0
	case nPUBiChoice = 10
		stor "'pcm'  $ cCategory" to cm0
	case nPUBiChoice = 11
		stor "'pfl'  $ cCategory" to cm0
	case nPUBiChoice = 12
		stor "'oth'  $ cCategory" to cm0
	endc
endi
if lPickDE
	if allt(aDEItems[nPUDEChoice]) = "All"
		stor ".T." to cm0
	else
		stor "ctitle = allt(aDEItems[nPUDEChoice])" to cm0
	endi
endi

stor ".T." to cd1
if lOnlyNewEntries
  stor cd1 + " and dLastMod >= {12/31/93}" to cd1
endi

stor ".T." to cm1
stor ".T." to cm2
stor ".T." to cm3
stor ".F." to cm4
stor ".F." to cm5
stor ".F." to cm6

if ! empt(uppe(allt(cCrit1)))
stor "uppe(allt(cCrit1)) $ uppe(mdescr)" to cm1
stor ".T." to cm2
stor ".T." to cm3
endi
if ! empt(uppe(allt(cCrit2)))
stor "uppe(allt(cCrit2)) $ uppe(mdescr)" to cm2
stor ".T." to cm3
endi
if ! empt(uppe(allt(cCrit3)))
stor "uppe(allt(cCrit3)) $ uppe(mdescr)" to cm3
endi
if ! empt(uppe(allt(cCrit4)))
stor "uppe(allt(cCrit4)) $ uppe(mdescr)" to cm4
stor ".T." to cm5
stor ".T." to cm6
endi
if ! empt(uppe(allt(cCrit5)))
stor "uppe(allt(cCrit5)) $ uppe(mdescr)" to cm5
stor ".T." to cm6
endi
if ! empt(uppe(allt(cCrit6)))
stor "uppe(allt(cCrit6)) $ uppe(mdescr)" to cm6
endi

sele 0
if lPickRG
	use tufr_rg
endi
if lPickBi
	use tufr_bi	
endi
if lPickDE
	use tufr_de
endi

set filt to &cm0 and &cd1 and ;
  (  ;
    (&cm1 and &cm2 and &cm3) ;
      or ;
    (&cm4 and &cm5 and &cm6) ;
  )

set cons off
report form TUFR_PRN to prin
set cons on
use
retu .T.

************************************************************
func fnPickDE
stor .F. to lPickRG, lPickBi
stor ".T." to cPopCondition
if lOnlyNewEntries
  stor cPopCondition + " and dLastMod >= {12/31/93}" to cPopCondition
endi

sele ctitle from tufr_de where &cPopCondition into arra adeitems
dime adeitems[alen(adeitems)+1]
=ains(adeitems,1)
stor "All" to adeitems[1]
use in TUFR_DE

if lPickDE 
	show gets enab
	show get nPURGChoice disa
	show get nPUBiChoice disa
endi
retu .T.

************************************************************
func fnPickRG
stor .F. to lPickBi, lPickDE
if lPickRG 
	show gets enab
	show get nPUBiChoice disa
	show get nPUDEChoice disa
endi
retu .T.

************************************************************
func fnPickBI
stor .F. to lPickRG, lPickDE
if lPickBi 
	show gets enab
	show get nPURGChoice disa
	show get nPUDEChoice disa
endi
retu .T.

************************************************************
func fnClear
stor "" to m.cCrit1, m.cCrit2, m.cCrit3, m.cCrit4, m.cCrit5, m.cCrit6
show gets
retu .T.
